<?php

if (!class_exists('EcwidRandomProductsEcwidStore'))
	require_once RANDOM_PRODUCTS_DIR . 'classes/EcwidStore.php';

class EcwidRandomProductsCachedEcwidStore extends EcwidRandomProductsEcwidStore {

	protected $EcwidProductApi;
	private $products = false;
	private $categories = false;
	private $profile = false;

	public function getRandomProducts($howMany) {

		$products = $this->getProductsInternal();
		return self::getProductsRandomly($howMany, $products);
	}

	public function getProfile() {

		if ($this->profile !== false)
			return $this->profile;

		$profile = EcwidRandomProductsCache::getCache('profile');

		if ($profile === false) {

			$profile = $this->EcwidProductApi->get_profile();
			EcwidRandomProductsCache::putCache('profile', $profile);

		}

		$this->profile = $profile;

		return $this->profile;

	}

	public function getProduct($productid) {
		
		$products = $this->getProductsInternal(); 

		return $products[$productid];

	}

	public function doesCategoryExist($categoryId) {

		$categories = $this->getCategoriesInternal();

		if (isset($categories[$categoryId]) && !empty($categories[$categoryId]['products'])) {

			return true;

		} else {

			return false;

		}

	}

        public function getRandomProductsFromCategory($howMany, $categoryId) {

                $products = $this->getAllProductsFromCategory($categoryId);

                return self::getProductsRandomly($howMany, $products);

        }

	private function getAllProductsFromCategory ($categoryId) {

		$currentCategory = $this->getCategory($categoryId);
		$return = false;

		if ($currentCategory !== false && $currentCategory['has_products']) {

			foreach ($currentCategory['products'] as $productid) {

				$return[] = $this->getProduct($productid);		
	
			}

		}

		return $return;

	}

	private function getCategory($categoryId) {

		$categories = $this->getCategoriesInternal();

		if (isset($categories[$categoryId])) {

			return $categories[$categoryId];
	
		} else {
		
			return false;

		}

	}

	private function getCategoriesInternal() {

		if ($this->categories !== false)
			return $this->categories;

		$categories = EcwidRandomProductsCache::getCache('categories');

		if ($categories === false) {

			$rawCategories = $this->EcwidProductApi->get_all_categories();

                        foreach ($rawCategories as $category) {

				$categoryId = $category['id'];
				$currentCategory = $category;

                                $products = $this->EcwidProductApi->get_products_by_category_id($categoryId);

				$currentCategory['products'] = array();
				$currentCategory['has_products'] = true;
			
				if ($products !== false) {

					$currentCategory['has_products'] = true;

					foreach ($products as $product) {


		                                $currentCategory['products'][] = $product['id'];

					}

				}

				$categories[$categoryId] = $currentCategory;

                        }

			EcwidRandomProductsCache::putCache('categories', $categories);

		}

		$this->categories = $categories;

		return $this->categories;

	}

	private function getProductsInternal() {

		if ($this->products !== false)
			return $this->products;

		$products = EcwidRandomProductsCache::getCache('products');

		if ($products === false) {

			$rawProducts = $this->EcwidProductApi->get_all_products();

			foreach ($rawProducts as $product) {

				$productFromEcwid = $this->EcwidProductApi->get_product($product['id']);

				$products[$product['id']] = array_merge($productFromEcwid, $product);

				
			}

			EcwidRandomProductsCache::putCache('products', $products);

		}

		$this->products = $products;

		return $this->products;

	}

}
