<?php

class EcwidRandomProductsEcwidStore {

	protected $EcwidProductApi;

	public function __construct() {

                if (!class_exists('EcwidProductApi')) {
                        include_once ABSPATH . 'wp-content/plugins/ecwid-shopping-cart/lib/ecwid_product_api.php';
                }

                $this->EcwidProductApi = self::createApiInstance();

	}

	public function getRandomProducts($howMany) {

		return $this->EcwidProductApi->get_random_products($howMany);
	
	}

	public function getProfile() { 

		return $this->EcwidProductApi->get_profile();

	}

	public function getProduct($productid) { 

		return $this->EcwidProductApi->get_product($productid);

	}

	protected function createApiInstance() {

                if (!class_exists('EcwidProductApi')) {
                        include_once ABSPATH . 'wp-content/plugins/ecwid-shopping-cart/lib/ecwid_product_api.php';
                }

                return new EcwidProductApi(get_ecwid_store_id());

	}

	public function doesCategoryExist($categoryId) {

		$products = $this->EcwidProductApi->get_products_by_category_id($categoryId);

		if ($products === false) {

			return false;

		} else {
		
			return true;

		}

	}

	public function getRandomProductsFromCategory($howMany, $categoryId) {

		$products = $this->EcwidProductApi->get_products_by_category_id($categoryId);	

		return self::getProductsRandomly($howMany, $products);

	}

	protected function getProductsRandomly($howMany, $products) {

                $countProducts = count($products);
                $productIds = array_keys($products);
                $usedProducts = array();
                $return = array();

                while ($howMany-- > 0) {

                        $key = rand(0, $countProducts - 1);

                        if ($howMany < $countProducts) {

                                while (in_array($key, $usedProducts))
                                        $key = rand(0, $countProducts - 1);

                                $usedProducts[] = $key;

                        }

                        $return[] = $products[$productIds[$key]];

                }

		return $return;
	}
}
