<?php

class EcwidRandomProductsProduct {

	private $id;
	private $categoryId;
	private $price;
	private $name;
	private $thumbnailUrl;
	private $productUrl;

	public function __construct ($id = 0) {

		if (intval($id) <= 0)
			return;

		$this->id = $id;

		$config = EcwidRandomProductsCoreSettings::getInstance();

		$product = $config->ecwidStore->getProduct($id);

		$this->categoryId = $product['categories'][0]['id'];
		$this->thumbnailUrl = $product['thumbnailUrl'];

		if (get_ecwid_protocol() == "https") {

			$this->thumbnailUrl = str_replace($search = 'http://', $replacement = 'https://', $this->thumbnailUrl);

		}

		$this->name = $product['name'];
		$this->price = sprintf('%01.2f', $product['price']);
		$this->productUrl = $config->getEcwidPageUrl()
                        	. (($config->isSeoCatalogEnabled()) ? '?ecwid_product_id=' . $this->id : '')
                                . '#ecwid:mode=product'
                                . '&category=' . $this->categoryId
                                . '&product=' . $this->id;

	}

	public function getName() {

		return $this->name;
	
	}

	public function getCategoryId() {

		return $this->categoryId;

	}

	public function getPrice() {

		return $this->price;

	}

	public function getThumbnailUrl() {

		return $this->thumbnailUrl;

	}

	public function getProductUrl() {

		return $this->productUrl;

	}

}
