<?php

class EcwidRandomProductsProductDisplay {

	function showProducts(
				EcwidRandomProductsProductGroup $productData,
				EcwidRandomProductsProductSettings $settings) {

		$config = EcwidRandomProductsCoreSettings::getInstance();

                if (!$config->canShowProducts()) {

                        return 'Ecwid page does not exist. Refer to <a href="http://kb.ecwid.com/w/page/15853324/WordPress#IhaveaccidentallydeletedmystorepageinWordPresswhatshouldIdonow">the article</a> in Ecwid&amp; KB in order to restore it.';

                }

		$products = $productData->getProducts();
		$productCounter = 0;

                $return = '<div class="ecwid-random-products"><table>';

                foreach ($products as $product) {

			$productCounter += 1;

                        if (1 == ($productCounter % ($settings->howManyPerRow()))) {

                                $return .= '<tr>';

                        }

                        $widthString = ($settings->getProductWidth() > 0) ? ' width=' . $settings->getProductWidth() . ' ' : '';
                        $return .= '<td' . $widthString . '>' . self::showProduct($product, $settings) . '</td>';

			if (0 == ($productCounter % ($settings->howManyPerRow()))) {

                                $return .= '</tr>';

                        } 

                }

                $return .= '</table></div>';

		return $return;

	}

	function showProduct(
			EcwidRandomProductsProduct $product,
			EcwidRandomProductsProductSettings $settings)
                         {

	        $return = '<div style="text-align: center;">';
        	$return .= '<a href="' . $product->getProductUrl() . '">';
                $return .= '<img src="' . $product->getThumbnailUrl() . '" title="' . $product->getName() . '" class="ecwid-random-thumbnail" />';
                $return .= '</a>';

                if ($settings->showTitle()) {

                        $return .= '<br />';
                        $return .= '<span>' . $product->getName() . '</span>';

                }

                if ($settings->showPrice()) {
		
			$config = EcwidRandomProductsCoreSettings::getInstance();
			$currency = $config->getCurrency();

                        $return .= '<br />';
                        $return .= '<span>' . $currency['prefix'] . $product->getPrice() . $currency['suffix'] . '</span>';

                }

                $return .= '</div>';

                return $return;		

	}

}
