<?php

class EcwidRandomProductsProductGroup {

	private $products;

	public function __construct($howMany, $parentCategoryId = 0) {

                $config = EcwidRandomProductsCoreSettings::getInstance();

		$howMany 		= (int) $howMany;
		$parentCategoryId 	= (int) $parentCategoryId;

		if ($howMany < 1)
			$howMany = 1;

		if ($parentCategoryId < 0)
			$parentCategoryId = 0;

		if ($parentCategoryId > 0 && $config->ecwidStore->doesCategoryExist($parentCategoryId)) {

			$products = $config->ecwidStore->getRandomProductsFromCategory($howMany, $parentCategoryId);

		} else {

	                $products = $config->ecwidStore->getRandomProducts($howMany);

		}

                foreach ($products as $product) {

			$this->products[] = new EcwidRandomProductsProduct($product['id']);

                }

	}

	public function getProducts() {

		return $this->products;

	}

}
